`timescale 1ns / 1ps

module test_points(RW_INI,
                   DCM_RST, DCM_LCK, DCM_RDY, INC_LC, RST_TMO, TMO_RST, TMO, RST_DONE,
                   MRST_DONE, RAW_POW_ON_RST, SER_CLK,
                   TP_B0_,TP_B1_,TP_B2_,TP_B5_,TP_B6_,
                   TP_CK_1S,TP_CK_2S,TP_CK_3P);

    input RW_INI;
    input DCM_RST;
    input DCM_LCK;
    input DCM_RDY;
    input INC_LC;
    input RST_TMO;
    input TMO_RST;
    input TMO;
    input RST_DONE;
    input MRST_DONE;
    input RAW_POW_ON_RST;
    input SER_CLK;
    inout [3:0] TP_B0_;
    inout [7:0] TP_B1_;
    inout [26:0] TP_B2_;
    inout [18:0] TP_B5_;
    inout [32:0] TP_B6_;
    inout TP_CK_1S;
    inout TP_CK_2S;
    inout TP_CK_3P;
   
assign TP_B0_ = {INC_LC,DCM_RDY,1'b0,RW_INI};   
assign TP_B1_ = {1'b0,RST_DONE,RAW_POW_ON_RST,DCM_LCK, DCM_RST, TMO_RST, RST_TMO, MRST_DONE};   
assign TP_B2_[26:22] = 5'h00;   
assign TP_B2_[21] = 1'b0;   
assign TP_B2_[20:0] = {20'h00000,TMO};   
assign TP_B5_ = 19'h00000;   
assign TP_B6_ = 33'h000000000;   
assign TP_CK_1S = 1'b0;   
assign TP_CK_2S = SER_CLK;   
assign TP_CK_3P = 1'b0;
   
endmodule
